unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms,
  Dialogs, GLScene, GLMesh, GLObjects, GLCoordinates,
  GLCrossPlatform, BaseClasses, GLWin32Viewer,
  StdCtrls,math,ExtDlgs, ExtCtrls,
  VectorTypes, VectorGeometry, GLState, GLColor, Buttons ;

type
  EDFig = record
    nom   : string;
    NP,NT : integer;
    APU   : array of TVector3f;
    APA   : array of TVector3i; // TRI
    cent  : TVector3f;
    Lcaj  : single;
    col   : TVector4f;
    // props aspecto
    pos   : TVector3f;
    ang   : TVector3f; // grados
    esc   : TVector3f;
  end;

  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    GLDummyCube2: TGLDummyCube;
    GLMesh1: TGLMesh;
    GLSphere1: TGLSphere;
    GLSphere2: TGLSphere;
    OpenDialog1: TOpenDialog;
    GLLightSource2: TGLLightSource;
    GLLightSource3: TGLLightSource;
    SavePictureDialog1: TSavePictureDialog;
    ColorDialog1: TColorDialog;
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label7: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Label8: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    Button3: TButton;
    Shape1: TShape;
    Label1: TLabel;
    Shape2: TShape;
    Label2: TLabel;
    Button4: TButton;
    Button1: TButton;
    Label9: TLabel;
    Edit10: TEdit;
    Label10: TLabel;
    Edit11: TEdit;
    Label11: TLabel;
    Edit12: TEdit;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Bevel1: TBevel;
    SpeedButton2: TSpeedButton;
    ListBox1: TListBox;

    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Button4Click(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
    px,py   : integer;
    ss      : single;
    BM      : TBitMap;

    fig     : EDFig;


    procedure Dibuja();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  GLMesh1.Vertices.Clear;
  ss := GLCamera1.SceneScale;
  BM := TBitMap.Create;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.02;
  if ss<0.2 then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.02;
  if ss>3 then ss := 3;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

procedure TForm1.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  col : Tcolor;
begin
  if ColorDialog1.Execute then begin
    col := ColorDialog1.Color;
    Shape1.Brush.Color := col;
    GLSceneViewer1.Buffer.BackgroundColor := col;
  end;
end;

procedure TForm1.Shape2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  col : Tcolor;
begin
  if ColorDialog1.Execute then begin
    col := ColorDialog1.Color;
    Shape2.Brush.Color := col;
  end;
end;

// Tomar foto
procedure TForm1.Button4Click(Sender: TObject);
var
  nom : string;
begin
  BM := GLSceneViewer1.CreateSnapShotBitmap;
  if SavePictureDialog1.Execute then begin
    nom := SavePictureDialog1.FileName;
    BM.SaveToFile(nom);
  end;
end;

// Limpiar
procedure TForm1.Button1Click(Sender: TObject);
begin
  GLMesh1.Vertices.Clear;
end;

// cargar
procedure TForm1.Button3Click(Sender: TObject);
var
  kk,du  : integer;
  nom    : string;
  aid    : TextFile;
  x1,x2,
  y1,y2,
  z1,z2,
  LL,ff  : single;
begin
  if OpenDialog1.Execute then begin
    nom := OpenDialog1.FileName;
    AssignFile(aid,nom);
    reset(aid);

    readln(aid);
    readln(aid,fig.NP,fig.NT);

    SetLength(fig.APU ,fig.NP);
    for kk := 0 to fig.NP - 1 do
      readln(aid,fig.APU[kk][0],
                 fig.APU[kk][1],
                 fig.APU[kk][2]);

    SetLength(fig.APA ,fig.NT);
    for kk := 0 to fig.NT - 1 do
      readln(aid,du, fig.APA[kk][0],
                     fig.APA[kk][1],
                     fig.APA[kk][2]);

    closeFile(aid);

    // centroide y caja
    // max y min
    x1 := fig.APU[0][0]; x2 := x1;
    y1 := fig.APU[0][1]; y2 := y1;
    z1 := fig.APU[0][2]; z2 := z1;
    for kk := 1 to fig.NP - 1 do begin
      x1 := MIN(x1, fig.APU[kk][0]);
      y1 := MIN(y1, fig.APU[kk][1]);
      z1 := MIN(z1, fig.APU[kk][2]);

      x2 := MAX(x2, fig.APU[kk][0]);
      y2 := MAX(y2, fig.APU[kk][1]);
      z2 := MAX(z2, fig.APU[kk][2]);
    end;

    fig.cent[0] := (x1+x2)/2;
    fig.cent[1] := (y1+y2)/2;
    fig.cent[2] := (z1+z2)/2;

    LL       := MAX(x2-x1,y2-y1);
    fig.Lcaj := MAX(LL,z2-z1);

    // centrado y escalado
    ff := 2/fig.Lcaj;
    for kk := 0 to fig.NP - 1 do begin
      fig.APU[kk][0] := ff*(fig.APU[kk][0]-fig.cent[0]);
      fig.APU[kk][1] := ff*(fig.APU[kk][1]-fig.cent[1]);
      fig.APU[kk][2] := ff*(fig.APU[kk][2]-fig.cent[2]);
    end;

    // parmetros propis
    fig.col := ConvertWinColor(Shape1.Brush.Color);

    SetVector(fig.pos,0,0,0);
    SetVector(fig.ang,0,0,0);
    SetVector(fig.esc,1,1,1);
    
    Dibuja();
  end;
end;

// Dibujar
procedure TForm1.Dibuja();
var
  nn          : TVector3f;
  cc          : TVector4f;
  kk,i0,i1,i2 : integer;
  colW        : TColor;
begin
  SetVector(nn,0,0,0);
  colW := Shape2.Brush.Color;
  cc := ConvertWinColor(colW);
  fig.col := cc;

  for kk := 0 to fig.NT - 1 do begin
    i0 := fig.APA[kk][0];
    i1 := fig.APA[kk][1];
    i2 := fig.APA[kk][2];

    GLMesh1.Vertices.AddVertex( fig.APU[i0],nn,cc);
    GLMesh1.Vertices.AddVertex( fig.APU[i1],nn,cc);
    GLMesh1.Vertices.AddVertex( fig.APU[i2],nn,cc);
  end;

  GLMesh1.CalcNormals(fwCounterClockWise);
end;

// Movimientos y escala
procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  vx,vy,vz  : single;
begin
  // posicion
  if CheckBox1.Checked then begin
    vx := StrToFloat(Edit1.Text);
    vy := StrToFloat(Edit2.Text);
    vz := StrToFloat(Edit3.Text);

    SetVector(fig.pos,vx,vy,vz);
    GLMesh1.Position.X := vx;
    GLMesh1.Position.Y := vy;
    GLMesh1.Position.Z := vz;
  end;

  // rotacion
  if CheckBox2.Checked then begin
    vx := StrToFloat(Edit4.Text);
    vy := StrToFloat(Edit5.Text);
    vz := StrToFloat(Edit6.Text);

    SetVector(fig.ang,vx,vy,vz);
    GLMesh1.PitchAngle := vx;
    GLMesh1.TurnAngle  := vy;
    GLMesh1.RollAngle  := vz;
  end;

  // escalas
  if CheckBox3.Checked then begin
    vx := StrToFloat(Edit4.Text);
    vy := StrToFloat(Edit5.Text);
    vz := StrToFloat(Edit6.Text);

    SetVector(fig.esc,vx,vy,vz);
//    GLMesh1.PitchAngle := vx;
//    GLMesh1.TurnAngle  := vy;
//    GLMesh1.RollAngle  := vz;
  end;

end;


// cambios por suma y resta
procedure TForm1.SpeedButton2Click(Sender: TObject);
var
  vx,vy,vz,
  rx,ry,rz   : single;
begin
  // posicion
  if CheckBox4.Checked then begin
    rx := StrToFloat(Edit1.Text);
    ry := StrToFloat(Edit2.Text);
    rz := StrToFloat(Edit3.Text);

    vx := StrToFloat(Edit10.Text);
    vy := StrToFloat(Edit11.Text);
    vz := StrToFloat(Edit12.Text);

    rx := rx + vx;
    ry := ry + vy;
    rz := rz + vz;

    Edit1.Text := Format('%6.2f',[rx]);
    Edit2.Text := Format('%6.2f',[ry]);
    Edit3.Text := Format('%6.2f',[rz]);

    SetVector(fig.pos,rx,ry,rz);
    GLMesh1.Position.X := rx;
    GLMesh1.Position.Y := ry;
    GLMesh1.Position.Z := rz;
  end;


end;

end.
